20200229题解

OJ 1190

二分答案,对每个答案进行判断,用并查集进行优化,将整个场地的左侧和右侧分别设为0和n+1,每个点覆盖的范围设为i,$O(n^2)$判断点之间是否连通,最后只需判断0和n+1是否连通即可。

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;

inline long long read() {
    long long ans = 0, f = 1;
    char ch = getchar();
    while(ch < ‘0‘ || ch > ‘9‘)
        f *= (ch == ‘-‘) ? -1 : 1, ch = getchar();
    do ans = ((ans << 1) + (ans << 3) + (ch ^ 48)), ch = getchar();
    while(ch >= ‘0‘ && ch <= ‘9‘);
    return ans * f;
}

const int MAXN = 2001;
const double esp = 1e-7;
double a[MAXN], b[MAXN], x, y;
int fa[MAXN], n;

inline int get(int x){
    return (fa[x] == x) ? x : fa[x] = get(fa[x]);
}

bool judge(double val){
    for(int i=0; i<=n+1; i++)
        fa[i] = i;
    for(int i=1; i<=n; i++){
        if(a[i] < val + esp || b[i] + val + esp > y) fa[get(i)] = get(0);
        if(b[i] < val + esp || a[i] + val + esp > x) fa[get(i)] = get(n+1);
    }
    for(int i=1; i<=n; i++)
        for(int j=1; j<=n; j++)
            if(i != j && (a[j] - a[i]) * (a[j] - a[i]) + (b[j] - b[i]) * (b[j] - b[i]) < val * val * 4 + esp)
                fa[get(i)] = get(j);
    return get(0) != get(n+1);
}

int main(){
    x = read(), y = read(), n = read();
    for(int i=1; i<=n; i++)
        a[i] = read(), b[i] = read();
    double l = 0, r = max(x, y);
    while(l + 1e-3 < r){
        double mid = (l + r) / 2;
        if(judge(mid)) l = mid;
        else r = mid;
    }
    printf("%.2lf", l);
    return 0;
}

OJ 1191

整个图是一个基环树,要求基环树直径,分为两种情况,一个是路径经过环,一个路径不经过环,第二种情况直接Dp求直径,对第一种情况使用动态规划

$ans = max(ans, Dp[i]+Dp[j]+sum[i]-sum[j]),i>j-len,sum[i]-sum[j]<=sum[len]/2$,单调队列优化即可

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

long long read(){
    long long ans = 0, f = 1;
    char ch = getchar();
    while(ch < ‘0‘ || ch > ‘9‘)
        f *= (ch == ‘-‘) ? -1 : 1, ch = getchar();
    do ans = ((ans << 1) + (ans << 3) + (ch ^ 48)), ch = getchar();
    while(ch >= ‘0‘ && ch <= ‘9‘);
    return ans * f;
}

const int MAXN = 1000005;
int head[MAXN], next[MAXN<<1], last[MAXN<<1], val[MAXN<<1], lineNum;
void add(int x,int y,int v){
    lineNum++, next[lineNum] = head[x], last[lineNum] = y, val[lineNum] = v, head[x] = lineNum;
}
int cir[MAXN<<1], top, len, sta[MAXN], vis[MAXN];
long long ans, ret, Dp[MAXN], ext[MAXN<<1];
int deq[MAXN<<1], L = 0, R = -1;

struct Edge{
    int x, y, val;
    const bool operator < (const Edge &temp) const{
        if(x != temp.x) return x < temp.x;
        if(y != temp.y) return y < temp.y;
        return val < temp.val;
    }
}e[MAXN];

void findCir(int x,int fa){
    sta[++top] = x, vis[x] = 1;
    for(int l = head[x]; l; l = next[l]){
        int y = last[l];
        if(y == fa) continue;
        if(vis[y] == 1){
            do cir[++len] = sta[top], vis[sta[top]] = 2;
            while(sta[top--] != y);
            continue;
        }
        if(!vis[y]) findCir(y, x);
    }
    if(vis[x] == 1)
        vis[x] = 2, top--;
}

void dfs(int x,int fa){
    for(int l = head[x]; l; l = next[l]){
        int y = last[l];
        if(y == fa || vis[y]) continue;
        dfs(y, x);
        ret = max(ret, Dp[x] + Dp[y] + val[l]);
        Dp[x] = max(Dp[x], Dp[y] + val[l]);
    }
}

int main(){
    int n = read();
    for(int i=1; i<=n; i++){
        e[i].x = read(), e[i].y = read(), e[i].val = read();
        if(e[i].x > e[i].y) swap(e[i].x, e[i].y);
    }
    sort(e+1, e+1+n);
    bool flag = false;
    for(int i=1; i<=n; i++){
        if(e[i].x == e[i].y) flag = true;
        else if(e[i].x == e[i-1].x && e[i].y == e[i-1].y) flag = true;
        else add(e[i].x, e[i].y, e[i].val), add(e[i].y, e[i].x, e[i].val);
    }
    if(flag){
        dfs(1, 0);
        printf("%lld", ret + 1);
        return 0;
    }
    findCir(1, -1);
    cir[0] = cir[len];
    for(int i=len+1; i<=len*2; i++)
        cir[i] = cir[i-len];
    for(int i=1; i<=len; i++)
        for(int l = head[cir[i]]; l; l = next[l])
            if(last[l] == cir[i-1])
                ext[i] = val[l];
    for(int i=len+1; i<=len*2; i++)
        ext[i] = ext[i-len];
    for(int i=1; i<=len*2; i++)
        ext[i] += ext[i-1];
    memset(vis, 0, sizeof(vis));
    for(int i=1; i<=len; i++){
        vis[cir[i-1]] = vis[cir[i+1]] = true;
        ret = 0, dfs(cir[i], -1);
        vis[cir[i-1]] = vis[cir[i+1]] = false;
        ans = max(ans, ret);
    }
    for(int i=1; i<=len*2; i++){
        while(L <= R && (deq[L] < i - len || ext[i] - ext[deq[L]] > ext[len] / 2))
            L++;
        if(L <= R)
            ans = max(ans, Dp[cir[i]] + Dp[cir[deq[L]]] + ext[i] - ext[deq[L]]);
        while(L <= R && Dp[cir[deq[R]]] - ext[deq[R]] <= Dp[cir[i]] - ext[i])
            R--;
        deq[++R] = i;
    }
    printf("%lld", ans + 1);
    return 0;
}

OJ 1192

使用树形Dp,Dp[MAXN][2],第二维表示以x为根的子树使用(不使用)传送阵的最短时间,转移方程:

$Dp[x][0] += Dp[y][0] + 2*val[l],Dp[x][1] += min(Dp[y][1] + 2*val[l], Dp[y][0] + val[l] - d[y])$

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;

long long read(){
    long long ans = 0, f = 1;
    char ch = getchar();
    while(ch < ‘0‘ || ch > ‘9‘)
        f *= (ch == ‘-‘) ? -1 : 1, ch = getchar();
    do ans = ((ans << 1) + (ans << 3) + (ch ^ 48)), ch = getchar();
    while(ch >= ‘0‘ && ch <= ‘9‘);
    return ans * f;
}

const int MAXN = 1000001;
int head[MAXN], next[MAXN<<1], last[MAXN<<1], val[MAXN<<1], lineNum;
void add(int x,int y,int v){
    lineNum++, next[lineNum] = head[x], last[lineNum] = y, val[lineNum] = v, head[x] = lineNum;
}
long long Dp[MAXN][2], d[MAXN];

void dfs(int x,int fa){
    for(int l = head[x]; l; l = next[l]){
        int y = last[l];
        if(y == fa) continue;
        dfs(y, x);
        d[x] = max(d[x], d[y] + val[l]);
        Dp[x][0] += Dp[y][0] + val[l] * 2;
        Dp[x][1] += min(Dp[y][1] + val[l] * 2, Dp[y][0] + val[l] - d[y]);
    }
}

int main(){
    int n = read();
    for(int i=1; i<n; i++){
        int x = read(), y = read(), v = read();
        add(x, y, v), add(y, x, v);
    }
    dfs(1, -1);
    printf("%lld", Dp[1][1]);
    return 0;
} 

原文地址:https://www.cnblogs.com/PHDHD/p/12383429.html

时间: 2024-10-13 23:09:25

20200229题解的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

HDU 1045 Fire Net 二分图Bipartite题解

本题可以使用DFS直接爆搜出答案,不过这样类型的题目其实是个二分图的题解. 这个二分图,难不在Hungary算法,而是难在于建图.需要挺高的抽象思维的. 建图: 1 把同一行不被X分开的格子标同一个号码,被X分开的标下一个号码,这样做是为了缩点,不需要把所有的格子都分开标号,而且可以更方便建个更加小的图. 2 同理把同一列的格子标号 3 然后判断相同一个格子的行标号和列标号是有路径的,其他不在同一个格子的都是没有路径的. 4 这样就等于以行标号和列标号作为左右顶点,构建成一个二分图了 然后使用H